import { computed, getCurrentInstance } from 'vue'
import { fromPairs } from '@/tools'
const DEFAULT_EXCLUDE_KEYS = ['class', 'style']
const LISTENER_PREFIX = /^on[A-Z]/

export const useAttrs = (params = {}) => {
  const { excludeListeners = false, excludeKeys = [], includeKeys = [] } = params
  const allExcludeKeys = excludeKeys.concat(DEFAULT_EXCLUDE_KEYS).filter(item => !includeKeys.includes(item))
  const instance = getCurrentInstance()
  if (!instance) {
    return computed(() => ({}))
  }
  return computed(() =>
    fromPairs(
      Object.entries(instance.proxy?.$attrs).filter(
        ([key]) => !allExcludeKeys.includes(key) && !(excludeListeners && LISTENER_PREFIX.test(key))
      )
    )
  )
}
