import { api_personalDepList } from '@/api'
import { ref } from 'vue'
import { formatDataItem } from '@/utils'

const commonGroups = ref([])
export function useCommonGroups() {
	const loading = ref(true)
	function getCommonGroups(params) {
		return api_personalDepList(params).then(res => {
			commonGroups.value = res.data.list
				.map(item => formatDataItem.commonGroup(item))
		}).finally(_ => {
			loading.value = false
		})
	}
	return {
		commonGroups, getCommonGroups, loading,
	}
}
