import { readonly, ref, reactive, watch } from 'vue'
import { tabs as _tabs } from '@/utils'

export function useTabs(props) {
	const tabs = ref([])
	watch(() => props.tabs, val => {
		tabs.value = val.reduce((result, curr) => {
			const target = _tabs.find(tab => tab.value === curr)
			target && result.push(target)
			return result
		}, [])
	}, { immediate: true })
	const activeTab = ref(tabs.value[0]?.value || 0)
	return {
		tabs: readonly(tabs), activeTab,
	}
}
